<?php

namespace FiloBlu\Rma\Model\Config\Backend;

use FiloBlu\Rma\Model\ResourceModel\Carrier\MatrixrateFactory;
use Magento\Framework\App\Cache\TypeListInterface;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\Config\Value;
use Magento\Framework\Data\Collection\AbstractDb;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Model\Context;
use Magento\Framework\Model\ResourceModel\AbstractResource;
use Magento\Framework\Registry;

/**
 *
 */
class Matrixrate extends Value
{
    /**
     * @var MatrixrateFactory
     */
    protected $matrixRateFactory;

    /**
     * Matrixrate constructor.
     * @param Context $context
     * @param Registry $registry
     * @param ScopeConfigInterface $config
     * @param TypeListInterface $cacheTypeList
     * @param MatrixrateFactory $matrixRateFactory
     * @param AbstractResource|null $resource
     * @param AbstractDb|null $resourceCollection
     * @param array $data
     */
    public function __construct(
        Context              $context,
        Registry             $registry,
        ScopeConfigInterface $config,
        TypeListInterface    $cacheTypeList,
        MatrixrateFactory    $matrixRateFactory,
        AbstractResource     $resource = null,
        AbstractDb           $resourceCollection = null,
        array                $data = []
    )
    {
        parent::__construct($context,
            $registry,
            $config,
            $cacheTypeList,
            $resource,
            $resourceCollection,
            $data);
        $this->matrixRateFactory = $matrixRateFactory;
    }

    /**
     * @return Value
     * @throws LocalizedException
     */
    public function afterSave()
    {
        /** @var \FiloBlu\Rma\Model\ResourceModel\Carrier\Matrixrate $matrixRate */
        $matrixRate = $this->matrixRateFactory->create();
        $matrixRate->uploadAndImport($this);
        return parent::afterSave();
    }
}
